
--version
mycurrent_version = "Current version: 0024.6.12.756p"

--Stock Factorio--
require("silo-script")
require("mod-gui")
local version = 1

guis = {frames={},buttons={}}

function init_vars()

  --GLOBAL SETTINGS
  global.actual_playtime = {}
  global.unlock_itemlist = {}
  global.unlock_itemlist_c = 0

  global.max_items_unlocks = 200 -- Safty
  
  global.player_afk_threshold = 18000 --5 mins
  global.earlygame_help = 108000 --30 minutes
  
  --tick loop delay--
  global.last_s_tick = 0
  global.s_delay = 120 --2 seconds
  --Debug messages--
  global.debugs = 1
  global.debugs_admin = 1
  --Voteban settings--
  global.voteban_disable = 0
  global.voteban_cooldown = 120 -- Two minutes 
  global.voteban_minvotes = 2 -- Min Votes
  global.voteban_ban_delay = 600 -- 10 seconds
  global.voteban_expires = 2700 -- 45 seconds
  global.voteban_min_for_percent = 7 --min to do percentage voting
  global.numplayers = 0
  --Permissions settings--
   global.player_probation_time = 10
   
end


-------------------------------------
-- FROM MOD, DONT TOUCH MY STUFF   --
-- Updated and simplified for 0.15 --
-- Original mod used tick timer    --
-- and used a ton of script time   --
-- and didn't unlock items for     --
-- players that left               --
-------------------------------------

-- Replacement handler --
script.on_event(defines.events.on_selected_entity_changed , function(event)

  local player = game.players[event.player_index]
    if ( player and player.valid and player.character and player.character.valid and player.connected ) then
          mine_check(player)
  end
end)

function lock_entity(entity)

  if ( entity == nil ) then
  return
  end
  if ( entity.valid == nil or entity.valid == false ) then
  return
  end
  
  if ( entity.last_user ~= nil ) then
    entity.minable = false
    entity.rotatable = false
    
    if ( global.unlock_itemlist == nil ) then
      global.unlock_itemlist = {}
    end
    if ( global.unlock_itemlist_c == nil ) then
      global.unlock_itemlist_c = 0
    end
    table.insert ( global.unlock_itemlist, entity )
    global.unlock_itemlist_c = ( global.unlock_itemlist_c + 1 )
    --log ( "locking: " .. entity.name )
    --log ( "queue: " .. global.unlock_itemlist_c )
    --log ( "id: " .. entity_id ( entity ) )
  end
end

function unlock_entity(entity)

  if ( entity == nil ) then
  return
  end
  if ( entity.valid == nil or entity.valid == false ) then
  return
  end

	--log ( "unlocking: " .. entity.name )
	--log ( "queue: " .. global.unlock_itemlist_c )
    --log ( "id: " .. entity_id ( entity ) )
    entity.minable = true
    entity.rotatable = true
end

function player_is_entity_owner(player, entity)

  if ( entity == nil ) then
  return
  end
  if ( entity.valid == nil or entity.valid == false ) then
  return
  end

  if ( player and player.valid and player.character and player.character.valid and player.connected ) then
  
     if ( player.permission_group ~= nil ) then
       if ( player.permission_group.name == "Admin" or player.permission_group.name == "Trusted" ) then
         return true
       end
     end
     
    local last_user = entity.last_user
    if last_user and last_user.index ~= player.index then return false else return true end
  end
  
return false
end

function mine_check(player)

    if ( player and player.valid and player.character and player.character.valid and player.connected ) then
    
    local selected = player.selected
    if selected and selected.valid then
        if player_is_entity_owner(player, selected) then
            -- unlock the entity when selected by the owner
            unlock_entity(selected)
        else
            -- lock the entity when selected by a non-owner
            lock_entity(selected)
        end
    end
    
   end
end

-- Player Creation --
script.on_event(defines.events.on_player_created, function(event)
  
  local player = game.players[event.player_index]
  if ( player and player.valid and player.character and player.character.valid ) then
  
    if ( global.actual_playtime == nil or global.actual_playtime[player.index] == nil ) then
      global.actual_playtime[player.index] = player.online_time
    end
  
  
  --Lets get things moving...
  if ( game.tick < global.earlygame_help ) then --First x ticks, players get extra items
  player.insert{name="iron-plate", count=25}
  player.insert{name="copper-plate", count=25}
  player.insert{name="stone", count=25}
  player.insert{name="coal", count=50}
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=25}
  player.insert{name="burner-mining-drill", count = 6}
  player.insert{name="stone-furnace", count = 4}
  player.insert{name="light-armor", count = 3}
  player.insert{name="steel-axe", count = 3}
  player.insert{name="transport-belt", count = 50}
  player.insert{name="underground-belt", count = 15}
  player.insert{name="burner-inserter", count = 15}
  else -- After that, they just get basics
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
  player.insert{name="light-armor", count = 1} --Anti-griefer
  player.insert{name="steel-axe", count = 1}
  end
  
  

  player.force.chart(player.surface, {{player.position.x - 200, player.position.y - 200}, {player.position.x + 200, player.position.y + 200}})
  player.force.friendly_fire = false
  silo_script.gui_init(player)
  
  end
  
end)

script.on_event(defines.events.on_player_respawned, function(event)
  local player = game.players[event.player_index]
  if ( player and player.valid and player.character and player.character.valid) then
  
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
  player.insert{name="light-armor", count = 1}
  player.insert{name="steel-axe", count = 1}
  
  end
  
end)


script.on_init(function()
  global.version = version
  silo_script.init()
  dist_init_voteban(true)
  init_vars()
end)

--Begin DIST--

--Game init--

script.on_load(function()


  if ( commands.commands.server_interface == nil ) then
  
  commands.add_command( "online", "See who is online", function(param)

  
  local numpeople = 0

    local victim = game.players[param.player_index]
    if ( victim and victim.valid and victim.character and victim.character.valid and victim.connected ) then
  
    for _, player in pairs(game.connected_players) do
      if ( player and player.valid and player.character and player.character.valid and player.connected ) then
        numpeople = (numpeople + 1)
        admintag = " "
        if ( player.admin ) then
          admintag = "  --  (ADMIN)"
        end
        if ( player.permission_group ~= nil ) then
        if ( player.permission_group.name == "Default" ) then
          admintag = "  --  (NEW)"
        end
        end
        
        if ( global.actual_playtime and global.actual_playtime[player.index] ) then
          victim.print( numpeople .. ": " .. player.name .."  -- AFK: " .. math.floor(player.afk_time / 60.0 / 60.0 ).. "  --  Played: " ..
          math.floor( global.actual_playtime[player.index] / 60.0 / 60.0 ) .. "  --  Online: " .. math.floor(player.online_time / 60.0 / 60.0 ) .. admintag )
        end
        
      end
    end
    
    end

  end)
  
  commands.add_command( "voteban", "Start or add to a voteban.", function(param)
    local player = game.players[param.player_index]
    
    if ( player and player.valid and player.character and player.character.valid and player.connected ) then
    
      if ( param == nil or param.parameter == nil ) then
        player.print("Usage: /voteban playername -- Votes to ban a player. (Admin: cancel)" )
      return
      end
    
    if ( player.admin and param.parameter == "cancel" and global.voteban_num > 0 ) then
      dist_init_voteban(false)
      game.print ( "(VOTEBAN) Voteban was canceled by an admin." )
      return
    end
    
    if ( global.voteban_disable == 1 ) then
      player.print("Voteban is disabled for the moment." )
      return
    end
    
    if param.parameter then
      local victim = game.players[param.parameter]
      
      if ( victim and victim.valid ) then
            --Go to voteban--
            get_permgroup() --Update permgroups
            if ( victim.permission_group ~= nil ) then
              if ( victim.permission_group.name ~= "Banned" ) then
                dist_voteban_add(player, victim)
              else
                player.print ( "They are already banned..." )
              end
            end
      else
        player.print("No such player... Names are case(capitalization) sensitive. Try tab-complete.")
        message_debug( player.name .. " is trying to voteban " .. param.parameter .. ", but there is no such player." )
      end
    end
    end
  end)
  
  end
  
end)

--Stock Factorio--
script.on_event(defines.events.on_rocket_launched, function(event)
  silo_script.on_rocket_launched(event)
end)

script.on_configuration_changed(function(event)
  if global.version ~= version then
    global.version = version
  end
  silo_script.on_configuration_changed(event)
end)
silo_script.add_remote_interface()


--Begin DIST--

--Auto permisisons--
function get_permgroup()

    global.trustedgroup = game.permissions.get_group("Trusted")
    global.admingroup = game.permissions.get_group("Admin")
    global.bangroup = game.permissions.get_group("Banned")
    
    if ( global.trustedgroup == nil ) then
      game.permissions.create_group("Trusted")
    end
    
    if ( global.admingroup == nil ) then
      game.permissions.create_group("Admin" )
    end
    
    if ( global.bangroup == nil ) then
      game.permissions.create_group("Banned" )
    end
    
    global.trustedgroup = game.permissions.get_group("Trusted")
    global.admingroup = game.permissions.get_group("Admin")
    global.bangroup = game.permissions.get_group("Banned")

    for _, player in pairs(game.connected_players) do
    if ( player and player.valid and player.character and player.character.valid and player.connected ) then
    
      if (player.admin) then
        if (player.permission_group ~= nil ) then
          if (player.permission_group.name ~= "Admin") then
            global.admingroup.add_player(player)
            message_debug ( player.name .. " moved to admins..." )
          end
        end
        
      else
        if ( global.actual_playtime and global.actual_playtime[player.index] and global.actual_playtime[player.index] > (global.player_probation_time * 60 * 60) ) then
          if ( player.permission_group ~= nil and player.permission_group.name == "Default" ) then
            if ( global.trustedgroup.add_player( player ) == true ) then
              player.print ( "(SERVER) You have now been playing long enough, that the new-user restrictions on your character have been lifted... Have fun, and be nice!" )
              message_debug ( player.name .. " was moved to trusted users." )
            end
          end
        end
        
      end
  end
  end
end

--Clear voteban--
function dist_init_voteban(boot)

  global.voteban_name = "None"
  global.voteban_age = 0
  global.voteban_num = 0
  
  if ( boot ) then
    global.voteban_last_ban = 0
  else
    global.voteband_last_ban = game.tick
  end
  
  global.voteban_voters = {}
  for x = 0, 1024 do
    global.voteban_voters[x] = "None"
  end
  
end

-- Return a string representing the unique entity id.
-- https://forums.factorio.com/viewtopic.php?f=25&t=32860&sid=a116fe079b1b058b91d496056a1b4fbe
function entity_id(entity)
    if not entity or not entity.valid then return nil end
    return entity.name .. "-" .. entity.position.x .. "-" .. entity.position.y .. "-" .. entity.surface.name .. "-"
end

--Tick loop--
--Keep to minimum--
script.on_event(defines.events.on_tick, function(event)

if ( global.old_version ~= mycurrent_version ) then
	init_vars()
	dist_init_voteban(true)
	global.old_version = mycurrent_version
end

if (game.tick - global.last_s_tick >= global.s_delay) then
    get_permgroup()
    dist_check_voteban()
    
    global.numplayers = 0
    
    
        for _, player in pairs(game.connected_players) do
      if ( player and player.valid and player.character and player.character.valid and player.connected ) then
      
      -- Actual playtime
      if ( global.actual_playtime == nil or global.actual_playtime[player.index] == nil ) then
        global.actual_playtime[player.index] = player.online_time
      end
      
        if ( player.afk_time < global.player_afk_threshold ) then
          global.numplayers = ( global.numplayers + 1 )
          
          if ( global.actual_playtime and global.actual_playtime[player.index] ) then
            global.actual_playtime[player.index] = ( global.actual_playtime[player.index] + ( global.s_delay - 1 ) )
          end
          
        end
      end
    end

    
local is_select = false
    
    if ( global.unlock_itemlist == nil ) then
      global.unlock_itemlist = {}
    end
    if ( global.unlock_itemlist_c == nil ) then
      global.unlock_itemlist_c = 0
    end
    
    if ( global.unlock_itemlist ) then
    for x, item in pairs ( global.unlock_itemlist ) do
    
    --Sane limit
    if ( x > global.max_items_unlocks ) then
      break;
    end
    is_select = false
    if ( item ) then
    
     for _, player in pairs(game.connected_players) do
      if ( player and player.valid and player.character and player.character.valid and player.connected ) then
        if ( player.selected and player.selected.valid ) then
          if ( item and item.valid and entity_id ( item )  == entity_id (player.selected ) ) then
            is_select = true
            --game.print ( entity_id (item) )
          end
        end
      end
    end
    
    if ( is_select == false ) then
      if ( item and item.valid ) then
        unlock_entity ( item )
      end
      --log ( "Removing: " .. entity_id ( global.unlock_itemlist[x] ) );
      table.remove ( global.unlock_itemlist, x )
      global.unlock_itemlist_c = ( global.unlock_itemlist_c - 1 )
    end
    

  end
  end
  end
    
    if ( global.unlock_itemlist_c > 50 ) then
      log ( "Item unlock queue: " .. global.unlock_itemlist_c )
    end
    
    global.last_s_tick = game.tick
  end
    
end)


-- Main voteban command --
function dist_voteban_add(player, victim)

  if ( player == nil or player.permission_group == nil ) then
    message_debug ( "voteban invalid player user or group" )
    return
  end
  
  if ( victim == nil or victim.permission_group == nil ) then
    message_debug ( "voteban invalid victim user or group" )
    return
  end
  
  if ( player and player.valid and player.character and player.character.valid and player.connected ) then
  if ( victim and victim.valid ) then
  if ( player.permission_group.name == "Trusted" or player.permission_group.name == "Admin" ) then
  
    if ( global.voteban_name ~= victim.name and global.voteban_name ~= "None" ) then
      player.print ( "You cant vote to ban someone else, until the current voteban completes or expires." )
    return
    end
    if ( ( game.tick - global.voteban_last_ban ) < global.voteban_cooldown ) then
      player.print ( "Last voteban was only " .. ( game.tick - global.voteban_last_ban ) .. " seconds ago... You will have to wait a while longer." )
      message_debug ( player.name .. " tried to voteban " .. victim.name .. " but it hasnt been long enough since last voteban yet." )
      return
    end
    if ( victim.admin == true ) then
      player.print ( "You can't ban admins..." )
      message_debug ( player.name .. " tried to voteban admin " .. victim.name )
      return
    end
    
    if ( global.voteban_voters == nil ) then
      message_debug ( player.name .. " voted but voteban_voters was nil." )
      dist_init_voteban(false)
      return
    end
    
    for _, check_player in pairs(global.voteban_voters) do
      if ( check_player == nil ) then
        return
      end
      if ( check_player == player.name ) then
        player.print ( "You already voted..." )
        message_debug ( player.name .. " tried to voteban, but had already voted..." )
        return
      end
    end
    
      global.voteban_name = victim.name
      global.voteban_age = game.tick
      global.voteban_num = (global.voteban_num + 1)             
      
      if ( global.numplayers >= global.voteban_min_for_percent ) then
        if ( global.voteban_num > 0 and (global.voteban_num / global.numplayers * 100 ) > 50.00 ) then
          player.print ( "Already enough votes..." )
          message_debug ( player.name .. " was late to the vote." )
          return
        end
      else
        if ( global.voteban_num > global.voteban_minvotes ) then
          player.print ( "Already enough votes..." )
          message_debug ( player.name .. " was late to the vote." )
          return
        end
      end
        
      global.voteban_voters[global.voteban_num] = player.name
      local percent_message = " "
      if ( global.voteban_num > 0 and global.numplayers >= global.voteban_min_for_percent  ) then
        percent_message = ("[%" .. math.floor(global.voteban_num / global.numplayers * 100 ).."] (%50 needed)" )
      end
      game.print ( "(VOTEBAN) " .. player.name .. " voted to ban " .. victim.name .. ". [ " .. global.voteban_num .." vote(s) ] " .. percent_message)
      return
  end
  
  player.print ( "Voteban is for trusted users, and admins only..." )
  message_debug ( player.name .. " tried to use voteban, but isnt eligible." )
  return
  end
  end
end


--Main voteban loop--
function dist_check_voteban()
  if ( ( game.tick - global.voteban_age ) > global.voteban_expires and global.voteban_num > 0 ) then
    dist_init_voteban(false)
    game.print ( "(VOTEBAN) Voteban expired... Not enough votes." )
  end
  if ( global.voteban_name == nil or global.voteban_name == "None" ) then
    return
  end
  
  local percent_reached = false
  
  if ( global.numplayers >= global.voteban_min_for_percent ) then
    if ( math.floor(global.voteban_num / global.numplayers * 100 ) > 50 ) then
      percent_reached = true
    end
  elseif ( global.numplayers < global.voteban_min_for_percent and global.voteban_num > global.voteban_minvotes ) then
    percent_reached = true
  end
  
  if ( percent_reached ) then
    if ( ( game.tick - global.voteban_age ) > ( global.voteban_ban_delay ) and global.voteban_name ~= nil and global.voteban_name ~= "None" ) then
      local victim = game.players[global.voteban_name]  
      if ( victim and victim.valid and victim.permission_group ) then
        if ( global.bangroup.add_player(victim) == true ) then
          game.print ( "(VOTEBAN) Votes reached... Banning " .. global.voteban_name .. "..." )
          dist_init_voteban(false)
        else
          game.print ( "(VOTEBAN) Votes reached... But there was an error attempting to ban " .. global.voteban_name .. "..." )
          dist_init_voteban(false)
        end
      end
    end
  end
end


--User login--
script.on_event(defines.events.on_player_joined_game, function(event)

addFrame('Info',0, 'MOTD', 'Info' )
		
addTab('Info','MOTD','Message Of The Day',
	function(player,frame)
  frame.add{name=1, type="label", caption={"", "--You can copy-paste text from this window!--"}}
  frame.add{name=2, type="label", caption={"", "New users start with some restrictions..."}}
  frame.add{name=3, type="label", caption={"", "Play for a while, and the restrictions will turn off."}}
  frame.add{name=4, type="label", caption={"", "Join our discord server, for polls, downloads and updates!"}}
  frame.add{name=5, type='textfield', text='https://discord.gg/HYCayGz'}.style.minimal_width=400
  frame.add{name=6, type="label", caption={"", "Server down? Problems? Discord: "}}
  frame.add{name=7, type='textfield', text='@Distortions#7165'}.style.minimal_width=400
  frame.add{name=8, type="label", caption={"", "Griefers? New command to ban players."}}
  frame.add{name=9, type='textfield', text='/voteban playername'}.style.minimal_width=400
  frame.add{name=10, type="label", caption={"", "Previous maps (dropbox):"}}
  frame.add{name=11, type='textfield', text='https://is.gd/luzuna'}.style.minimal_width=400
  frame.add{name=12, type="label", caption={"", "Forums: (signup is fast!)"}}
  frame.add{name=13, type='textfield', text='http://www.bhmm.net/factorio/forums/'}.style.minimal_width=400
end)
		
addTab('Info','Credits','Credits',
	function(player,frame)
  frame.add{name=1, type="label", caption={"", "Voteban system: Distortions864"}}
  frame.add{name=2, type="label", caption={"", "Anti-grief: Distortions864"}}
  frame.add{name=3, type="label", caption={"", "Mining blocking: Distortions864"}}
  frame.add{name=4, type="label", caption={"", "Some GUI calls: explosivegaming.nl"}}
  frame.add{name=5, type="label", caption={"", "Pointers and advice: Nexela"}}
  frame.add{name=6, type="label", caption={"", "Hosting service: bhmm.net, on nocix.net"}}
end)

addTab('Info','Changelog','Changelog',
	function(player,frame)
  frame.add{name=1, type="label", caption={"", mycurrent_version}}
  frame.add{name=2, type="label", caption={"", "5/23: Global Announcements"}}
  frame.add{name=3, type="label", caption={"", "5/27: Votekick system added"}}
  frame.add{name=4, type="label", caption={"", "5/28: Info screen (Replaced Announcements)"}}
  frame.add{name=5, type="label", caption={"", "5/28: Small votekick bugfix"}}
  frame.add{name=6, type="label", caption={"", "5/29: Voteban system replaced votekick"}}
  frame.add{name=7, type="label", caption={"", "5/29: Anti-grief v1.5"}}
  frame.add{name=8, type="label", caption={"", "5/31: General patches, and command /online"}}
  frame.add{name=9, type="label", caption={"", "6/3: Patch for deconstruction planner issue"}}
  frame.add{name=10, type="label", caption={"", "6/5: Bug fixes, performance enhancements"}}
  frame.add{name=11, type="label", caption={"", "6/5: Voteban tweaks, server rename"}}
  frame.add{name=12, type="label", caption={"", "6/10: Major desync fix (thanks rseding!)"}}
  
end)

local player = game.players[event.player_index]
  if ( player and player.valid and player.character and player.character.valid and player.connected ) then
	
  if ( global.actual_playtime == nil or global.actual_playtime[player.index] == nil ) then
    global.actual_playtime[player.index] = player.online_time
  end
  
  	drawToolbar(player)
	drawFrame(player,'Info','MOTD')
  end
end)


--GUI calls--
--from explosivegaming.nl--
----------------------------------------------------------------------------------------
---------------------------Gui Functions------------------------------------------------
----------------------------------------------------------------------------------------
function addFrame(frame,rank,open,caption,tooltip,sprite)
	guis.frames[frame] = {{require=rank,caption=caption,tooltip=tooltip,sprite=sprite}}
	addButton('close', function(player,element) element.parent.parent.parent.destroy() end)
	addButton('btn_'..frame, function(player,element) if player.gui.center[frame] then player.gui.center[frame].destroy() else drawFrame(player,frame,open) end end)
end

function addTab(frame, tabName, describtion, drawTab)
	guis.frames[frame][tabName] = {tabName, describtion, drawTab}
	addButton(tabName, function(player, element) openTab(player, element.parent.parent.parent.name, element.parent.parent.parent.tab, element.name) end)
end

function addButton(btnName, onClick)
	guis.buttons[btnName] = {btnName, onClick}
end

function drawButton(frame, btnName, caption, describtion, sprite)
	if sprite then
		frame.add{name=btnName, type = "sprite-button", sprite=sprite, tooltip=describtion, style = mod_gui.button_style}
	else
		frame.add{name=btnName, type = "button", caption=caption, tooltip=describtion, style = mod_gui.button_style}
	end
end

function openTab(player, frameName, tab, tabName)
	local tabBar = player.gui.center[frameName].tabBarScroll.tabBar
	for _,t in pairs(guis.frames[frameName]) do
		if _ ~= 1 then
			if t[1] == tabName then
				tabBar[t[1]].style.font_color = {r = 255, g = 255, b = 255, player = 255}
				tab.clear()
				t[3](player, tab)
			else
				tabBar[t[1]].style.font_color = {r = 170, g = 170, b = 170, player = 255}
			end
		end
	end
end

function drawFrame(player, frameName, tabName)
	if 0 <= guis.frames[frameName][1].require then
		player.gui.center.clear()
		local frame = player.gui.center.add{name=frameName,type='frame',caption=frameName,direction='vertical',style=mod_gui.frame_style}
		local tabBarScroll = frame.add{type = "scroll-pane", name= "tabBarScroll", vertical_scroll_policy="never", horizontal_scroll_policy="auto"}
		local tabBar = tabBarScroll.add{type='flow',direction='horizontal',name='tabBar'}
		local tab = frame.add{type = "scroll-pane", name= "tab", vertical_scroll_policy="auto", horizontal_scroll_policy="never"}
		for _,t in pairs(guis.frames[frameName]) do
			if _ ~= 1 then drawButton(tabBar, t[1], t[1], t[2]) end
		end
		openTab(player, frameName, tab, tabName)
		drawButton(tabBar, 'close', '(X) Close', 'Close this window')
		tab.style.minimal_height = 400
		tab.style.maximal_height = 400
		tab.style.minimal_width = 400
		tab.style.maximal_width = 400
		tabBarScroll.style.minimal_height = 60
		tabBarScroll.style.maximal_height = 60
		tabBarScroll.style.minimal_width = 500
		tabBarScroll.style.maximal_width = 500
		player.gui.center.add{type='frame',name='temp'}.destroy()
	end
end

function toggleVisable(frame)
	if frame then
		if frame.style.visible == nil then
			frame.style.visible = false 
		else
			frame.style.visible = not frame.style.visible
		end
	end
end

----------------------------------------------------------------------------------------
---------------------------Tool Bar-----------------------------------------------------
----------------------------------------------------------------------------------------
function drawToolbar(player)
  local frame = mod_gui.get_button_flow(player)
	for _,f in pairs(guis.frames) do
		if frame["btn_".._] then frame["btn_".._].destroy() end
		drawButton(frame,"btn_".._, f[1].caption, f[1].tooltip, f[1].sprite)
  end
end

----------------------------------------------------------------------------------------
---------------------------Gui Events---------------------------------------------------
----------------------------------------------------------------------------------------
script.on_event(defines.events.on_gui_click, function(event)
	silo_script.on_gui_click(event) -- do not remove part of factorio default
  local player = game.players[event.player_index]
  if ( player and player.valid and player.character and player.character.valid and player.connected ) then
  
	if event.element.type == 'button' or event.element.type == 'sprite-button' then
		for _,btn in pairs(guis.buttons) do
			if btn[1] == event.element.name then
				if btn[2] then btn[2](player,event.element) else callRank('Invaid Button'..btn[1],'Mod') end
				break
			end
		end
	elseif event.element.type == 'checkbox' then
		if event.element.name == 'select' then
			global.selected[event.player_index] = global.selected[event.player_index] or {}
			selected = global.selected[event.player_index]
			if event.element.state then
				table.insert(selected,event.element.parent.name)
			else
				for _,name in pairs(selected) do
					if name == event.element.parent.name then table.remove(selected,_) break end
				end
			end
		end
	end
  end
end)

--Debug messages--
function message_admins(message)
for _, player in pairs(game.connected_players) do
  if ( player and player.valid and player.character and player.character.valid and player.connected ) then
    if ( player.admin ) then
      player.print(message)
    end
  end
end
end

function message_debug(message)
if ( global.debugs == 0 ) then
  return
end

if ( global.debugs_admin == 1 ) then
  message_admins( "(INFO) " .. message)
  return
end

for _, player in pairs(game.connected_players) do
  if ( player and player.valid and player.character and player.character.valid and player.connected ) then
    if (player.name == "Distortions864") then
      player.print( "(INFO) " .. message)
      return
    end
  end
end
end


